<?php
/*
_____________
doTheMath

Version 1.0.0

_____________
L I C E N S E

Copyright (c) 2010, Alexander Sasse <alexander.sasse@xelaton.com>

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without 
 limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of 
 the Software, and to permit persons to whom the Software is furnished to do so, subject to the following 
 conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

_________
U S A G E

________________________
R E L E A S E  N O T E S
1.0 Initial Release
1.0.1 Added functionality to use () for more complex math
*/ 
 
function calculate($input)
{ 
 
$var = explode("\n", $input);
$original = $var;
## einzelne Zeilen durchgehen und "," gegen "." austauschen
$lineCounter = 0;
$errorOnLine = "";
$errorExspectedType = "";
$actualType = "";
$finalErgArray = array();
$totalSumErgArray = array();
foreach($var as &$line)
{
	## Kommas in Computerverständliche Notation umwandeln
	$line = str_replace(",", ".", $line);
	$line = str_replace("(", " ( ", $line);
	$line = str_replace(")", " ) ", $line);
	## Zeilenumbrüche entfernen, diese machen Zahlen unbrauchbar
	$line = str_replace("\n", " ", $line);
	## Wörter filtern
	$piecesOfLine = explode(" ", $line);
	$cleanedString = "";
	foreach($piecesOfLine as $piece)
	{
		$piece = trim($piece);
		# prüfen auf Zahl oder Mathematisches Zeichen
		if(is_numeric($piece) || $piece == "+" || $piece == "-" || $piece == "*" || $piece == "/" || $piece == "==" || $piece == "=$=" || $piece == "(" || $piece == ")")
		{					
			if($piece == "==")
			{
				$finalErgArray[] = $lineCounter;
				$actualType = '';
			}
			elseif($piece == "=$=")
			{
				$totalSumErgArray[] = $lineCounter;
				$piece = "";
				$actualType = '';
			}
			elseif($piece == "+" || $piece == "-" || $piece == "*" || $piece == "/")
			{
				if('mathSign' == $actualType)
				{
					$errorOnLine[] = $lineCounter;
					$errorExspectedType[] = 'Number exspected';
				}				
				else
				{
					$actualType = 'mathSign';
				}
			}
			elseif(is_numeric($piece))
			{
				if('number' == $actualType)
				{
					if(strstr($piece, "+") || strstr($piece, "-"))
					{
						$actualType = 'number';
					}
					else
					{
						$errorOnLine[] = $lineCounter;
						$errorExspectedType[] = 'Math-Sign exspected';
					}
				}
				else
				{
					$actualType = 'number';
				}
			}
			elseif($piece == "(" || $piece == ")")
			{
				
			}
			
			$cleanedString .= " ".$piece;
		}
	}
	$line = $cleanedString;	
	$lineCounter++;
}

if(is_array($errorOnLine))
{
?>
<style type="text/css">
<!--
* html body 
{
height:100%;
}
.errorMessages
{
	
background: -webkit-gradient(linear, left top, left bottom, from(darkred), to(red)); 
color:white; 
width: 400px; 
padding: 5px;
	padding-left: 10px;
	-webkit-border-radius: 10px;
	background-color: red;
	text-align: left;
border: darkred solid 3px;
	-webkit-box-shadow: 2px 2px 15px white;
}
-->
</style>
<body>
<div align="center">
<div class="errorMessages">
<?php
	echo "<div align='center'><strong>Invalid Calculation</strong></div>
	<br /> Following errors have been found:<br /><br />";
	for($i = 0; $i < count($errorOnLine); $i++)
	{
		echo "Line: <strong>".$errorOnLine[$i]."</strong>\t\t".$errorExspectedType[$i]."<br />";
	}
	?>
</div>
</div>
</body>
<?php		
	die();
	}
	
	//echo "<pre>"; var_dump($var); echo "</pre>";
	$finalMathString = implode("", $var);
//	echo $finalMathString."<br />";
	$finalMathString = preg_replace('/\([ ]{1,}\)/is', '', $finalMathString);
	//echo $finalMathString;
	//die();
	## prüfen ob mehrere Rechungen vorliegen
	$divertedTasks = explode("==", $finalMathString);
	if(is_array($divertedTasks))
	{
		foreach($divertedTasks as $task)
		{
			if(trim($task) != "")
			{
				$erg = 0;
				@eval("\$erg = $task; ");
				$results[] = $erg;
			}
		}
	}
	else
	{
		$erg = 0;
		@eval("\$erg = $finalMathString; ");
		echo $erg;
	}
	
	
	?>
<style type="text/css">
<!--
* html body 
{
height:100%;
}
-->
</style>
<body>
<div style="float:left; background-color: none; border-right: #FF6633 solid 2px; padding-right: 5px; width: 300px;">
<?php
	
	for($i = 0; $i < count($original); $i++)
	{
		if(strpos($original[$i], "==") === false && strpos($original[$i], "=$=") === false)
		{
			echo str_replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;", $original[$i])."<br />";
		}
		elseif(strpos($original[$i], "=$=") === false)
		{
			echo "<strong>".$original[$i]."</strong><hr style='border:solid white 1px;'/>";
		}
		elseif(is_numeric(strpos($original[$i], "=$=")))
		{
			echo "<strong>Total</strong><hr style='border:dashed white 1px;'/>";
		}
	}
	
	?>
<br />	
</div>
<div style="margin-left: 310px; padding-left: 5px; padding-right: 5px; background-color: none; border-left: #FF6633 solid 2px; background: -webkit-gradient(linear, left top, left bottom, from(#FEF8BC), to(#FCF184)); color:black; width: 150px; -webkit-border-top-right-radius: 5px; -webkit-border-bottom-right-radius: 5px; ">
<?php
$ergCounter = 0; # Counter für die Zwischenergebnisse
$totalCounter = 0; # Counter für die Summe der Zwischenergebnisse
$totalCounterForErg = 0; # Counter der angib ab welchen Zwischenergebnis zusammengerechnet werden soll
for($i = 0; $i < count($original); $i++)
{
if($finalErgArray[$ergCounter] == $i)
{
	$formattedResult = number_format($results[$ergCounter], 2, ',','');
	echo "<strong>$formattedResult</strong><hr style='border:solid black 1px;' />";
	$ergCounter++;
}
elseif($totalSumErgArray[$totalCounter] == $i && is_numeric($totalSumErgArray[$totalCounter]))
{
	$totalResult = 0;
	for($y = $totalCounterForErg; $y < $ergCounter; $y++)
	{ 
		$totalResult += $results[$y];
		$totalCounterForErg++;
	}
	$totalResult = number_format($totalResult, 2, ',','');
	$totalCounter++;
	echo "<strong>Total $totalResult</strong><hr style='border:dashed black 1px;' />";
}
else
{
	echo "<br />";
}
}

}
?>	
